DevMode: Per-project service control
====================================

This utility lets you start the services that you need when you need them,
as defined in a per-project manifest file.


## Usage

Install using composer:

    $ composer global require noccylabs/devmode:@dev

Make sure that your `~/.composer/vendor/bin` is on your path.

Next, create a `devmode.json` manifest in the root of your project:

    {
        "uses": {
            "mongodb": true
        }
    }

Now, from the terminal, to start the service(s):

    $ devmode up

And to stop them again:

    $ devmode down



## Plugin functionality

### Use a specific memcached instance

    "memcached/instance_name": true

To start all, either of these works:

    "memcached/all": true
    "memcached": true

### Use a symfony web server

    "symfony/httpd": true
    "symfony/httpd": { "bind":"127.0.0.1:8123" }

### Use any service

    "service_name": true

