<?php

namespace NoccyLabs\DevMode;

class Manifest
{
    protected $manifest;

    protected $dependencies = [];

    public function __construct($manifestFile=null)
    {
        if (!$manifestFile) {
            $manifestFile = getcwd()."/devmode.json";
        }
        
        if (!file_exists($manifestFile)) {
            throw new \RuntimeException("{$manifestFile} not found");
        }
        
        $this->readManifest($manifestFile);
    }

    private function readManifest($filename)
    {
        $json = file_get_contents($filename);
        $config = json_decode($json);

        $this->manifest = $config;

        if (!empty($config->uses)) {
            foreach ($config->uses as $id=>$conf) {
                $dep = new Dependency($id, $conf);
                $this->dependencies[] = $dep;
            }
        }
    }

    public function getDependencies()
    {
        return $this->dependencies;
    }
}
