<?php

namespace NoccyLabs\DevMode;

abstract class Plugin
{
    protected $manifest;
    
    protected $application;

    abstract public function onLoad();
    
    public function setManifest($manifest)
    {
        $this->manifest = $manifest;
    }

    public function getManifest()
    {
        return $this->manifest;
    }
    
    public function setApplication(Application $application)
    {
        $this->application = $application;
    }

    public function getId()
    {
        return $this->manifest->plugin;
    }

    protected function exec(...$cmdl)
    {
        $cmd = [ escapeshellcmd(array_shift($cmdl)) ];
        foreach ($cmdl as $arg) {
            $cmd[] = escapeshellarg($arg);
        }
        $cmd = join(" ",$cmd);
        printf("\e[32;1m[%s] exec: %s\e[0m\n", $this->getId(), $cmd);
        echo "\e[32m";
        passthru($cmd);
        echo "\e[0m";
    }
    
    protected function execBackground(...$cmdl)
    {
        $cmd = [ escapeshellcmd(array_shift($cmdl)) ];
        foreach ($cmdl as $arg) {
            $cmd[] = escapeshellarg($arg);
        }
        $cmd = join(" ",$cmd);
        printf("\e[32;1m[%s] exec: %s\e[0m\n", $this->getId(), $cmd);
        $pid = pcntl_fork();
        if ($pid === 0) {
            exec($cmd); // "sh -c \"{$cmd}\" &>/dev/null &");
            exit(0);
        }
    }
    
    protected function execSudo(...$cmdl)
    {
        // note: gksudo doesn't remember auth like sudo does, prompts repeatedly...
        //if (getenv('DISPLAY') && (trim(exec("which gksudo")))) {
        //    $this->exec("gksudo", "-kS", ...$cmdl);
        //} else {
            $this->exec("sudo", ...$cmdl);
        //}
    }
}
